package org.springblade.estate.feign;

import com.baomidou.mybatisplus.core.metadata.IPage;
import io.swagger.annotations.ApiParam;
import org.springblade.core.mp.support.BladePage;
import org.springblade.core.tool.api.R;
import org.springblade.estate.dto.GuestRecordDTO;
import org.springblade.estate.entity.GuestRecord;
import org.springblade.estate.vo.GuestRecordVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import javax.validation.Valid;
import java.util.List;

/**
 *  Feign
 *
 * @author lianghanqiang
 * @since 2021-03-30
 */
@FeignClient(value = "cyzh-estate",path = "/feign/guest")
public interface IGuestRecordClient {

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	GuestRecordVO detail(@SpringQueryMap GuestRecord guestRecord);

	/**
	 * 查询
	 */
	@GetMapping("/list")
	List<GuestRecordVO> list(@SpringQueryMap GuestRecord guestRecord);


	/**
	 * 查询
	 */
	@GetMapping("/count")
	Integer count(@SpringQueryMap GuestRecord guestRecord);

	/**
	 * 查询
	 */
	@PostMapping("/page")
	BladePage<GuestRecordVO> page(@RequestBody GuestRecordDTO guestRecordDTO);



	/**
	 * 新增
	 */
	@PostMapping("/save")
	boolean save(@Valid @RequestBody GuestRecord guestRecord);

	/**
	 * 修改
	 */
	@PostMapping("/update")
    boolean update(@Valid @RequestBody GuestRecord guestRecord);

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
    boolean submit(@Valid @RequestBody GuestRecord guestRecord);


	/**
	 * 删除
	 */
	@PostMapping("/remove")
    boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids);

	@GetMapping("/getById")
	GuestRecord getById(@RequestParam Long id);

	@PostMapping(value = "/audit")
	R audit(@RequestBody GuestRecord guestRecord);


}
